package arzumify.polyenergy.impl;

import arzumify.polyenergy.api.EnergyProvider;
import net.minecraft.util.math.Vec3i;

import java.util.ArrayList;

public record ProviderDetails(ArrayList<Vec3i> pointsOfPresence, EnergyProvider provider, int range) {
    public static ProviderDetails NewSimple(Vec3i position, EnergyProvider provider) {
        var pointsOfPresence = new ArrayList<Vec3i>();
        pointsOfPresence.add(position);
        return new ProviderDetails(pointsOfPresence, provider, 1);
    }

    public boolean isInRange(ArrayList<Vec3i> pointsOfPresence) {
        for (Vec3i point : pointsOfPresence) {
            for (Vec3i myPoint : this.pointsOfPresence) {
                var manhattanDistance = point.getManhattanDistance(myPoint);
                if (manhattanDistance == 0) {
                    return false;
                } else if (manhattanDistance <= range) {
                    return true;
                }
            }
        }
        return false;
    }
}
